=== modified file 'lisp/progmodes/sql.el'
--- old/lisp/progmodes/sql.el	2010-01-13 08:35:10 +0000
+++ new/lisp/progmodes/sql.el	2010-04-16 03:07:36 +0000
@@ -2375,26 +2900,22 @@
   (sql-product-interactive 'oracle))
 
 (defun sql-connect-oracle ()
-  "Create comint buffer and connect to Oracle using the login
-parameters and command options."
+  "Create comint buffer and connect to Oracle."
   ;; Produce user/password@database construct.  Password without user
   ;; is meaningless; database without user/password is meaningless,
   ;; because "@param" will ask sqlplus to interpret the script
   ;; "param".
-  (let ((parameter
-         (if (not (string= "" sql-user))
-             (if (not (string= "" sql-password))
-                 (concat sql-user "/" sql-password)
-               sql-user))))
+  (let ((parameter nil))
+    (if (not (string= "" sql-user))
+	(if (not (string= "" sql-password))
+	    (setq parameter (concat sql-user "/" sql-password))
+	  (setq parameter sql-user)))
     (if (and parameter (not (string= "" sql-database)))
 	(setq parameter (concat parameter "@" sql-database)))
-    (setq parameter (if parameter
-                        (nconc (list parameter) sql-oracle-options)
-                      sql-oracle-options))
-    (set-buffer (apply 'make-comint "SQL" sql-oracle-program nil parameter))
-    ;; SQL*Plus is buffered on WindowsNT; this handles &placeholders.
-    (if (eq window-system 'w32)
-	(setq comint-input-sender 'sql-query-placeholders-and-send))))
+    (if parameter
+	(setq parameter (nconc (list parameter) sql-oracle-options))
+      (setq parameter sql-oracle-options))
+    (sql-connect sql-oracle-program parameter)))
 
 
 
@@ -2411,7 +2932,7 @@
 `sql-database' as defaults, if set.  Additional command line parameters
 can be stored in the list `sql-sybase-options'.
 
-The buffer is put in sql-interactive-mode, giving commands for sending
+The buffer is put in `sql-interactive-mode', giving commands for sending
 input.  See `sql-interactive-mode'.
 
 To specify a coding system for converting non-ASCII characters
@@ -2426,8 +2947,7 @@
   (sql-product-interactive 'sybase))
 
 (defun sql-connect-sybase ()
-  "Create comint buffer and connect to Sybase using the login
-parameters and command options."
+  "Create comint buffer and connect to Sybase."
   ;; Put all parameters to the program (if defined) in a list and call
   ;; make-comint.
   (let ((params sql-sybase-options))
@@ -2439,8 +2959,7 @@
 	(setq params (append (list "-P" sql-password) params)))
     (if (not (string= "" sql-user))
 	(setq params (append (list "-U" sql-user) params)))
-    (set-buffer (apply 'make-comint "SQL" sql-sybase-program
-		       nil params))))
+    (sql-connect sql-sybase-program params)))
 
 
 
@@ -2455,7 +2974,7 @@
 Interpreter used comes from variable `sql-informix-program'.  Login uses
 the variable `sql-database' as default, if set.
 
-The buffer is put in sql-interactive-mode, giving commands for sending
+The buffer is put in `sql-interactive-mode', giving commands for sending
 input.  See `sql-interactive-mode'.
 
 To specify a coding system for converting non-ASCII characters
@@ -2470,12 +2989,14 @@
   (sql-product-interactive 'informix))
 
 (defun sql-connect-informix ()
-  "Create comint buffer and connect to Informix using the login
-parameters and command options."
+  "Create comint buffer and connect to Informix."
   ;; username and password are ignored.
-  (set-buffer (if (string= "" sql-database)
-                  (make-comint "SQL" sql-informix-program nil)
-                (make-comint "SQL" sql-informix-program nil sql-database "-"))))
+  (let ((db (if (string= "" sql-database)
+		"-"
+	      (if (string= "" sql-server)
+		  sql-database
+		(concat sql-database "@" sql-server)))))
+    (sql-connect sql-informix-program (list db "-"))))
 
 
 
@@ -2494,7 +3015,7 @@
 `sql-server' as defaults, if set.  Additional command line parameters
 can be stored in the list `sql-sqlite-options'.
 
-The buffer is put in sql-interactive-mode, giving commands for sending
+The buffer is put in `sql-interactive-mode', giving commands for sending
 input.  See `sql-interactive-mode'.
 
 To specify a coding system for converting non-ASCII characters
@@ -2509,17 +3030,21 @@
   (sql-product-interactive 'sqlite))
 
 (defun sql-connect-sqlite ()
-  "Create comint buffer and connect to SQLite using the login
-parameters and command options."
+  "Create comint buffer and connect to SQLite."
   ;; Put all parameters to the program (if defined) in a list and call
   ;; make-comint.
   (let ((params))
     (if (not (string= "" sql-database))
 	(setq params (append (list sql-database) params)))
+    (if (not (string= "" sql-server))
+	(setq params (append (list (concat "--host=" sql-server)) params)))
+    (if (not (string= "" sql-password))
+	(setq params (append (list (concat "--password=" sql-password)) params)))
+    (if (not (string= "" sql-user))
+	(setq params (append (list (concat "--user=" sql-user)) params)))
     (if (not (null sql-sqlite-options))
 	(setq params (append sql-sqlite-options params)))
-    (set-buffer (apply 'make-comint "SQL" sql-sqlite-program
-		       nil params))))
+    (sql-connect sql-sqlite-program params)))
 
 
 
@@ -2538,7 +3063,7 @@
 `sql-server' as defaults, if set.  Additional command line parameters
 can be stored in the list `sql-mysql-options'.
 
-The buffer is put in sql-interactive-mode, giving commands for sending
+The buffer is put in `sql-interactive-mode', giving commands for sending
 input.  See `sql-interactive-mode'.
 
 To specify a coding system for converting non-ASCII characters
@@ -2553,8 +3078,7 @@
   (sql-product-interactive 'mysql))
 
 (defun sql-connect-mysql ()
-  "Create comint buffer and connect to MySQL using the login
-parameters and command options."
+  "Create comint buffer and connect to MySQL."
   ;; Put all parameters to the program (if defined) in a list and call
   ;; make-comint.
   (let ((params))
@@ -2562,14 +3086,15 @@
 	(setq params (append (list sql-database) params)))
     (if (not (string= "" sql-server))
 	(setq params (append (list (concat "--host=" sql-server)) params)))
+    (if (not (and sql-port (numberp sql-port)))
+	(setq params (append (list (concat "--port=" (number-to-string sql-port))) params)))
     (if (not (string= "" sql-password))
 	(setq params (append (list (concat "--password=" sql-password)) params)))
     (if (not (string= "" sql-user))
 	(setq params (append (list (concat "--user=" sql-user)) params)))
     (if (not (null sql-mysql-options))
 	(setq params (append sql-mysql-options params)))
-    (set-buffer (apply 'make-comint "SQL" sql-mysql-program
-		       nil params))))
+    (sql-connect sql-mysql-program params)))
 
 
 
@@ -2585,7 +3110,7 @@
 the variables `sql-user', `sql-password', and `sql-server' as
 defaults, if set.
 
-The buffer is put in sql-interactive-mode, giving commands for sending
+The buffer is put in `sql-interactive-mode', giving commands for sending
 input.  See `sql-interactive-mode'.
 
 To specify a coding system for converting non-ASCII characters
@@ -2600,8 +3125,7 @@
   (sql-product-interactive 'solid))
 
 (defun sql-connect-solid ()
-  "Create comint buffer and connect to Solid using the login
-parameters and command options."
+  "Create comint buffer and connect to Solid."
   ;; Put all parameters to the program (if defined) in a list and call
   ;; make-comint.
   (let ((params))
@@ -2611,8 +3135,7 @@
 	(setq params (append (list sql-user sql-password) params)))
     (if (not (string= "" sql-server))
 	(setq params (append (list sql-server) params)))
-    (set-buffer (apply 'make-comint "SQL" sql-solid-program
-		       nil params))))
+    (sql-connect sql-solid-program params)))
 
 
 
@@ -2627,7 +3150,7 @@
 Interpreter used comes from variable `sql-ingres-program'.  Login uses
 the variable `sql-database' as default, if set.
 
-The buffer is put in sql-interactive-mode, giving commands for sending
+The buffer is put in `sql-interactive-mode', giving commands for sending
 input.  See `sql-interactive-mode'.
 
 To specify a coding system for converting non-ASCII characters
@@ -2642,12 +3165,12 @@
   (sql-product-interactive 'ingres))
 
 (defun sql-connect-ingres ()
-  "Create comint buffer and connect to Ingres using the login
-parameters and command options."
+  "Create comint buffer and connect to Ingres."
   ;; username and password are ignored.
-  (set-buffer (if (string= "" sql-database)
-                  (make-comint "SQL" sql-ingres-program nil)
-                (make-comint "SQL" sql-ingres-program nil sql-database))))
+  (sql-connect sql-ingres-program
+		 (if (string= "" sql-database)
+		     nil
+		   (list sql-database))))
 
 
 
@@ -2664,7 +3187,7 @@
 as defaults, if set.  Additional command line parameters can be stored
 in the list `sql-ms-options'.
 
-The buffer is put in sql-interactive-mode, giving commands for sending
+The buffer is put in `sql-interactive-mode', giving commands for sending
 input.  See `sql-interactive-mode'.
 
 To specify a coding system for converting non-ASCII characters
@@ -2679,8 +3202,7 @@
   (sql-product-interactive 'ms))
 
 (defun sql-connect-ms ()
-  "Create comint buffer and connect to Microsoft using the login
-parameters and command options."
+  "Create comint buffer and connect to Microsoft SQL Server."
   ;; Put all parameters to the program (if defined) in a list and call
   ;; make-comint.
   (let ((params sql-ms-options))
@@ -2699,8 +3221,7 @@
 	;; If -P is passed to ISQL as the last argument without a
 	;; password, it's considered null.
 	(setq params (append params (list "-P")))))
-    (set-buffer (apply 'make-comint "SQL" sql-ms-program
-		       nil params))))
+    (sql-connect sql-ms-program params)))
 
 
 
@@ -2717,7 +3238,7 @@
 Additional command line parameters can be stored in the list
 `sql-postgres-options'.
 
-The buffer is put in sql-interactive-mode, giving commands for sending
+The buffer is put in `sql-interactive-mode', giving commands for sending
 input.  See `sql-interactive-mode'.
 
 To specify a coding system for converting non-ASCII characters
@@ -2737,8 +3258,7 @@
   (sql-product-interactive 'postgres))
 
 (defun sql-connect-postgres ()
-  "Create comint buffer and connect to Postgres using the login
-parameters and command options."
+  "Create comint buffer and connect to Postgres."
   ;; username and password are ignored.  Mark Stosberg suggest to add
   ;; the database at the end.  Jason Beegan suggest using --pset and
   ;; pager=off instead of \\o|cat.  The later was the solution by
@@ -2751,8 +3271,7 @@
 	(setq params (append (list "-h" sql-server) params)))
     (if (not (string= "" sql-user))
 	(setq params (append (list "-U" sql-user) params)))
-    (set-buffer (apply 'make-comint "SQL" sql-postgres-program
-		       nil params))))
+    (sql-connect sql-postgres-program params)))
 
 
 
@@ -2768,7 +3287,7 @@
 uses the variables `sql-user', `sql-password', and `sql-database' as
 defaults, if set.
 
-The buffer is put in sql-interactive-mode, giving commands for sending
+The buffer is put in `sql-interactive-mode', giving commands for sending
 input.  See `sql-interactive-mode'.
 
 To specify a coding system for converting non-ASCII characters
@@ -2783,8 +3302,7 @@
   (sql-product-interactive 'interbase))
 
 (defun sql-connect-interbase ()
-  "Create comint buffer and connect to Interbase using the login
-parameters and command options."
+  "Create comint buffer and connect to Interbase."
   ;; Put all parameters to the program (if defined) in a list and call
   ;; make-comint.
   (let ((params sql-interbase-options))
@@ -2794,8 +3312,7 @@
 	(setq params (append (list "-p" sql-password) params)))
     (if (not (string= "" sql-database))
         (setq params (cons sql-database params))) ; add to the front!
-    (set-buffer (apply 'make-comint "SQL" sql-interbase-program
-		       nil params))))
+    (sql-connect sql-interbase-program params)))
 
 
 
@@ -2810,7 +3327,7 @@
 Interpreter used comes from variable `sql-db2-program'.  There is not
 automatic login.
 
-The buffer is put in sql-interactive-mode, giving commands for sending
+The buffer is put in `sql-interactive-mode', giving commands for sending
 input.  See `sql-interactive-mode'.
 
 If you use \\[sql-accumulate-and-indent] to send multiline commands to
@@ -2830,14 +3347,13 @@
   (sql-product-interactive 'db2))
 
 (defun sql-connect-db2 ()
-  "Create comint buffer and connect to DB2 using the login
-parameters and command options."
+  "Create comint buffer and connect to DB2."
   ;; Put all parameters to the program (if defined) in a list and call
   ;; make-comint.
-  (set-buffer (apply 'make-comint "SQL" sql-db2-program
-		     nil sql-db2-options))
-  ;; Properly escape newlines when DB2 is interactive.
-  (setq comint-input-sender 'sql-escape-newlines-and-send))
+  (sql-connect sql-db2-program sql-db2-options)
+)
+;;   ;; Properly escape newlines when DB2 is interactive.
+;;   (setq comint-input-sender 'sql-escape-newlines-and-send))
 
 ;;;###autoload
 (defun sql-linter ()
@@ -2850,7 +3366,7 @@
 Interpreter used comes from variable `sql-linter-program' - usually `inl'.
 Login uses the variables `sql-user', `sql-password', `sql-database' and
 `sql-server' as defaults, if set.  Additional command line parameters
-can be stored in the list `sql-linter-options'. Run inl -h to get help on
+can be stored in the list `sql-linter-options'.  Run inl -h to get help on
 parameters.
 
 `sql-database' is used to set the LINTER_MBX environment variable for
@@ -2859,7 +3375,7 @@
 for this to work).  If `sql-password' is an empty string, inl will use
 an empty password.
 
-The buffer is put in sql-interactive-mode, giving commands for sending
+The buffer is put in `sql-interactive-mode', giving commands for sending
 input.  See `sql-interactive-mode'.
 
 \(Type \\[describe-mode] in the SQL buffer for a list of commands.)"
@@ -2867,21 +3383,26 @@
   (sql-product-interactive 'linter))
 
 (defun sql-connect-linter ()
-  "Create comint buffer and connect to Linter using the login
-parameters and command options."
+  "Create comint buffer and connect to Linter."
   ;; Put all parameters to the program (if defined) in a list and call
   ;; make-comint.
-  (let ((params sql-linter-options) (login nil) (old-mbx (getenv "LINTER_MBX")))
+  (let ((params sql-linter-options)
+        (login nil)
+        (old-mbx (getenv "LINTER_MBX")))
+
     (if (not (string= "" sql-user))
 	(setq login (concat sql-user "/" sql-password)))
     (setq params (append (list "-u" login) params))
+
     (if (not (string= "" sql-server))
 	(setq params (append (list "-n" sql-server) params)))
+
     (if (string= "" sql-database)
 	(setenv "LINTER_MBX" nil)
       (setenv "LINTER_MBX" sql-database))
-    (set-buffer (apply 'make-comint "SQL" sql-linter-program nil
-		       params))
+
+    (sql-connect sql-linter-program params)
+
     (setenv "LINTER_MBX" old-mbx)))
 
 
@@ -2890,3 +3411,4 @@
 
 ;; arch-tag: 7e1fa1c4-9ca2-402e-87d2-83a5eccb7ac3
 ;;; sql.el ends here
+

